`timescale 1ns/1ps

module decimsimu;
reg [3:0] hpsel;
reg [6:1] mod;
reg mck, wck, oldbck;
wire lrck, bck, i2sdata, fclipled;

integer Jaap;
integer Piet;

decimation decim(hpsel, mod, mck, wck, lrck, bck, i2sdata, fclipled);
// hpsel selects high-pass frequency for second-order IIR high-pass
// Pull-ups on all hpsel wires, coding:
// 4'b1110: 0 Hz except during the first few seconds (autocalibration mode)
// 4'b1101: 1.2 Hz at 88.2 kHz sample rate
// 4'b1011: 4.8 Hz
// 4'b0111: 9.7 Hz
// default: 1.2 Hz


initial
begin
	hpsel = 4'b0111;
	Jaap = 0;
	mck = 1'b0;
	wck = 1'b0;
	mod = 6'b111111;
	oldbck = 1'b0;
	Piet = $fopen("decimuit.txt");
	for (Jaap = 1; Jaap < 1000001; Jaap = Jaap + 1)
	begin
		#48 mck = ~mck;
		#2 wck = ~wck;
		#48 mck = ~mck;
		if (bck && (!oldbck)) $fdisplay(Piet, Jaap," ",lrck, " ",i2sdata);
		#2 mod = ~mod;
		oldbck = bck;
		// Expected: large negative value left, large positive right
	end
	$fflush;
	$fclose(Piet);
	$finish;
end
endmodule
